/***************************************************************************/
/*                                                                         */
/* FILE NAME : ga_operator.c                                               */
/*                                                                         */
/* GA operators                                                            */
/*                                                                         */
/***************************************************************************/

#include "ga.h"
#include <stdio.h>

extern double zs[MAX_POP];
extern float p[MAX_POP];
extern int spop, nodecount;
extern int bstr[MAX_POP][MAX_ND];
extern FILE *fp;
extern int rnd();
extern double calc_fitness();

void select_maters(copy) /* roulette wheel selection */
int *copy;
{
  int j,k, nassign;
  float fraction[MAX_POP];

  j = k = 0;

  while ((j < spop)&&(j<MAX_POP)) 
  {
     nassign = p[j];
     fraction[j] = p[j] - nassign;
     
     while ((nassign > 0) && (nassign<100)) 
     {
       nassign--;
       if(k<MAX_POP) copy[k] = j;
       k++;
     }/* end of while */

     j++;

  }/* end of while */
     
  j = 0;

  while((k < spop)&&(j<spop))
    {
      if (j >= spop) j=0;
      /*
      printf("fraction[%d] = %6.2f k=%d spop= %d \n", j, fraction[j],k,spop); 
      */
      if (fraction[j] > 0 ) 
	if ( preflip( fraction[j] ) == 1 ) 
    {
	  *(copy+k) = j;
	  fraction[j]--;
	  k++;
	}
      j++;
    }

}


int select_mate(copyp, remp)
int *copyp, *remp;
{
  int ilast, pick, tempi;

  ilast = --(*remp);
  pick = rnd(0, ilast);
  tempi = *(copyp+pick);
  *(copyp+pick) = *(copyp+ilast);
  *(copyp+ilast) = tempi;
  /*return (tempi); */
  return (tempi%spop);
}

adjust_bit(xp)
int *xp;
{
  int i, ln = nodecount, count0, count1;

  i = rnd(0, nodecount-1);
  count0 = count1 = 0;

  /*while (ln > 0) */
  while ((ln > 0)&&(i<nodecount)) 
    {
      if (i==nodecount) i=0;
      if(*(xp+i) == 0) 
	{
	  if (count0 < nodecount/2)
	    count0++;
	  else 
	    {
	      *(xp+i) = 1;
	      count1++;
	    }
	}
      else
	{
	  if (count1 < nodecount/2)
	    count1++;
	  else
	    {
	      *(xp+i) = 0;
	      count0++;
	    }
	}
      i++;
      ln--;
    }
}
	

void xover(dadp, momp, xdp, xmp,cross_prob)
int dadp, momp;
int *xdp, *xmp;
float cross_prob;
{
  int i, startp, lnth, tempb;
  int *temp;
  double zsd, zsm, ztemp;

  /*
  printf("\n I am in xover ");
  printf("\n dadp=%d, momp=%d ", dadp, momp); 
  */

  if((dadp<0)||(dadp>=spop)||(momp<0)||(momp>=spop))
  {   
     printf("\n There is something WEIRD dadp=%d, momp=%d ", dadp, momp); 
     return; 
  }
  
  if (zs[dadp] < zs[momp]) 
    {
      tempb = dadp;
      dadp = momp;
      momp = tempb;
    }

  for (i=0; i<nodecount; i++)
    {
      *(xdp+i) = bstr[dadp][i];
      *(xmp+i) = bstr[momp][i];
    }

  if (dadp == momp || (cross_prob<rnd(0,1.0))) 
  {  /*printf("\n No Crossover \n"); */
     return; /* No crossover needed */
  }
     startp = rnd(0, nodecount-1);
     lnth = rnd(1, nodecount-1);

     if ( (startp+lnth) > nodecount )
     {
        startp = startp + lnth - nodecount;
        lnth = startp + nodecount - lnth;
     }

    for (i=startp; i<lnth; i++)
    {
       tempb = *(xdp+i);
       *(xdp+i) = *(xmp+i);
       *(xmp+i) = tempb;
    }

    adjust_bit(xdp);
    adjust_bit(xmp);

    zsd = calc_fitness(xdp);
    zsm = calc_fitness(xmp);

    if (zsd < zsm)
    {
       temp = xdp;
       xdp = xmp;
       xmp = temp;
       ztemp = zsd;
       zsd = zsm;
       zsm = ztemp;
    } 

    /* zsd > zsm > zs[dadp] > zs[momp] */
    if (zsm >= zs[dadp]) 
    {
       for (i=0; i<nodecount; i++) *(xdp+i) = bstr[dadp][i];
       for (i=0; i<nodecount; i++) *(xmp+i) = bstr[momp][i];
    }  
    /* (zsd, zs[dadp]) >= zsm >= zs[momp] */
    else if (zsm >= zs[momp]) 
       for (i=0; i<nodecount; i++) *(xdp+i) = bstr[momp][i];  
    /* zsd > zs[dadp] > zs[momp] > zsm */
    else if (zsd > zs[dadp])  
         {
            for (i=0; i<nodecount; i++) *(xdp+i) = bstr[momp][i];
            if (zsm==0) for (i=0; i<nodecount; i++) *(xmp+i) = bstr[dadp][i];
         } 
    /* zs[dadp] > zsd > zs[momp] > zsm */
    else if (zsd > zs[momp]) 
         {
            if (zsm==0) for (i=0; i<nodecount; i++) *(xmp+i) = *(xdp+i);
            for (i=0; i<nodecount; i++) *(xdp+i) = bstr[momp][i];

         } 
    /* zs[dadp] > zs[momp] > zsd > zsm */
    else  
       {
          if (zsm==0) {
	      for (i=0; i<nodecount; i++) *(xmp+i) = bstr[momp][i];
	      if (zsd == 0) for (i=0; i<nodecount; i++) *(xdp+i) = bstr[dadp][i];
          }
       }  


/*  fprintf(fp,"\nxdp = ");
  for (i=0; i<nodecount; i++)
      fprintf(fp, "%d", *(xdp+i));
  fprintf(fp,"\nxmp = ");
  for (i=0; i<nodecount; i++)
      fprintf(fp, "%d", *(xmp+i));   */

}

void swap(x,y,nodecount)
int x,y,nodecount;
{  int i,j;
   double dummy;

   if(x!=y)
   {  for(j=0;j<nodecount;j++)
      {  i=bstr[y][j];
         bstr[y][j]=bstr[x][j];
         bstr[x][j]=i;
      }
      dummy = zs[y];
      zs[y] = zs[x];
      zs[x] = dummy;
   }
}

void duplicate(x,y,nodecount)
int x,y,nodecount;
{  int i;
   for(i=0;i<nodecount;i++) bstr[y][i]=bstr[x][i];
   zs[y] = zs[x];
}

void elit(nodecount,spop)
int nodecount, spop;
{  int i, j, besti, worsti;
   double dummy;
   worsti=besti = 0;

   for(i=1;i<spop;i++)
      { if(zs[besti]>zs[i]) besti=i;
        if(zs[worsti]<zs[i]) worsti=i;
      }
  
   swap(besti,0,nodecount);
   swap(worsti,1,nodecount);
   duplicate(besti,worsti,nodecount);

}/* end of elit() */

void reproduction(cross_prob)
float cross_prob;
{
  int copy[MAX_POP],i, j, ngene[MAX_POP][MAX_ND];
  int remp, dad, mom, xstrd[MAX_ND], xstrm[MAX_ND];

  /*
  printf("\n Inside REPRODUCTION : before select_maters \n");
  */

  select_maters(copy);

  /*
  printf("\n Inside REPRODUCTION \n");
  */

/*  for (i=0; i<spop; i++) fprintf(fp, "copy[%d] = %d\n", i, copy[i]); */

  remp = spop;

  for (i=0; i<spop; i += 2)
    {
      dad = select_mate(copy, &remp);
      mom = select_mate(copy, &remp);
/*      fprintf(fp, "dad = %3d  mom = %3d\n", dad, mom);   */

      /*printf("before xover\n"); */

      /*xover(dad, mom, xstrd, xstrm);*/

      xover(abs(dad)%spop, abs(mom)%spop, xstrd, xstrm,cross_prob);

      /* printf("after xover\n"); */

      for (j=0; j<nodecount; j++)
	  {  ngene[i][j] = xstrd[j];
	     ngene[i+1][j] = xstrm[j];

	  }/* end of for */

    }/* end of for */

  for (i=0; i<spop; i++) 
    for (j=0; j<nodecount; j++) bstr[i][j] = ngene[i][j];
 

  /*
  printf("\n End of REPRODUCTION \n");
  */

/*  for (i=0; i<spop; i++) fprintf(fp, "copy[%d] = %d\n", i, copy[i]); */
}

void select_mutant(remp)
int *remp;
{
  int ilast, pick, tempi, i, count0, count1;
  int mutant[MAX_ND], startp, lnth;

  ilast = --(*remp);
  pick = rnd(0, ilast);
  for (i=0; i<nodecount; i++) mutant[i] = bstr[pick][i];
  for (i=0; i<nodecount; i++) bstr[pick][i] = bstr[ilast][i];

  startp = rnd(0, nodecount-1);
  lnth = rnd(1, nodecount-1)/4;
  if (lnth == 0) lnth = 1; 
  count0 = count1 = 0;
  i = startp;
  while (count0 < lnth || count1 < lnth)
    {
      if (mutant[i] == 0 && count0<lnth)
	{
	  mutant[i] = 1;
	  count0++;
	}
      if (mutant[i] == 1 && count1<lnth)
	{
	  mutant[i] = 0;
	  count1++;
	}
      if ( (++i) == nodecount ) i=0;
    }

  for (i=0; i<nodecount; i++) bstr[ilast][i] = mutant[i];      
}


void mutation()
{
  int remp=spop, i;

  for (i=0; i<(int) (spop/4); i++) select_mutant(&remp);
}
